uniform sampler2D ReflectionTexture;
uniform vec4 AddedColor;
uniform vec4 MultiColor;
uniform float UnderWater;
uniform float WaveDisplacement;
uniform float WaveRepetition;
uniform float RefractionFactor;
varying float addition;

void main()
{
   vec4 projCoord = gl_TexCoord[0] / gl_TexCoord[0].w;
   projCoord += vec4( 1.0 );
   projCoord *= 0.5;
   projCoord.x += sin( addition * WaveRepetition ) * ( WaveDisplacement / 1000.0 );
   projCoord.y += cos( addition * WaveRepetition ) * ( WaveDisplacement / 1000.0 );
   projCoord = clamp( projCoord, 0.001, 0.999 );

   if( UnderWater == 0.0 )
      projCoord.y = 1.0 - projCoord.y;

   vec4 refTex = texture2D( ReflectionTexture, vec2( projCoord ) );
   refTex = (refTex + AddedColor) * MultiColor;
   gl_FragColor = refTex;

   if( UnderWater == 1.0 )
      gl_FragColor *= ( MultiColor / 1.1 );

   gl_FragColor.a = RefractionFactor;
}